import torch
import torch.utils
import torch.utils.data

import argparse
import pickle

from model import RMDNSimple, RMDN_Uout, RMDN_Udirect, FRMDN
from model import gmm, gmm_Uout #, gmm_loss

from DataLoader import DataLoaderr as DataLoader

torch.manual_seed(0)

SERVER = 139 # 138 or 139

class Hyperparameter():
    def __init__(self, args):
        self.x_dim = args.X
        self.y_dim = args.Y
        self.h_dim = args.H
        self.n_layers = args.L
        self.n_epochs = args.E
        self.learning_rate = args.LR
        self.batch_size = args.B
        self.gaussians = args.K
        self.n_block = args.BL
        self.dprim = args.Dprim
        # self.do_clip = bool(args.C)
        if (args.C == "no"):
            self.do_clip = False
        else:
            self.do_clip = True
        self.clip = args.CL
        self.name = args.N
        if (args.No == "no"):
            self.make_noise = False
        else:
            self.make_noise = True
        # self.make_noise =bool(args.No)
        if (args.F == "no"):
            self.do_flow = False
        else:
            self.do_flow = True
        # self.do_flow = bool(args.F)
        self.cov_type = args.COV
        # self.is_separate = args.S
        self.Opt = args.Op

        self.activation = args.AC
        self.activation_parameter = args.PA

        if (args.R == "no"):
            self.do_resume = False
        else:
            self.do_resume = True

        self.setting = 'flow_' + str(self.do_flow) + '_cov_' + str(self.cov_type)  + '_dprim_' + str(self.dprim) + '_activation_' + str(self.activation)  + '_parameter_' + str(self.activation_parameter) +'_hdim_' + str(self.h_dim) + '_layer_' + str(self.n_layers ) + '_epoch_' + \
          str(self.n_epochs) + '_lr_' + str(self.learning_rate) + '_batch_' + str(self.batch_size) + \
          '_K_' + str(self.gaussians) + '_block_' + str(self.n_block) + '_doclip_' + str(self.do_clip) + '_clip_' + str(self.clip) + '_noise_' + str(self.make_noise) + '_opt_' + str(self.Opt) + '_resume_' + str(self.do_resume)
        self.device = torch.device('cuda' if torch.cuda.is_available() else 'cpu')

if (SERVER == 138):
    info = {'accent': {'total_number': 2921,
                                   'train_number': 2628,
                                   'test_number': 146,
                                   'validation_number': 146,
                                   'mu': 0.24, #0.25, #-0.99 for only 16
                                   'var': 962.28, #957.05, #957.05, #2445.26 for only 16  # std
                                   #  'mu': -0.99, # for only 16
                                   # 'var': 2445.26, #for only 16  # std
                                   'audio_path_train': '/hdd2/fatemeh/VRNN1/Accent/output16/train/',
                                   'audio_path_test': '/hdd2/fatemeh/VRNN1/Accent/output16/test/',
                                   'audio_path_validation': '/hdd2/fatemeh/VRNN1/Accent/output16/validation/',
                                   'pkl_path': '/hdd2/fatemeh/VRNN1/Accent/output16/{}.pkl',
                                   # 'save_path_model': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pt',
                                   # 'save_path_results': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pkl'},
                                    'save_path_model': '/hdd4/fatemeh/paper/models/{}_{}.pt',
                                   'save_path_results': '/hdd4/fatemeh/paper/logs/{}_{}.pkl'},
               'timit': {'total_number': 3360,
                              'train_number': 1680,
                              'test_number': 1680,
                              'validation_number': 0,
                              'mu': -0.0045,
                              'var': 526.25,
                              'audio_path_train': '/hdd2/fatemeh/TIMIT/data/timit-train/',
                              'audio_path_test': '/hdd2/fatemeh/TIMIT/data/timit-test/',
                              'pkl_path': '/hdd2/fatemeh/TIMIT/data/timit-{}.pkl',
                              # 'save_path_model': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pt',
                              # 'save_path_results': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pkl'}
                               'save_path_model': '/hdd4/fatemeh/paper/models/{}_{}.pt',
                               'save_path_results': '/hdd4/fatemeh/paper/logs/{}_{}.pkl'},
               # 'blizzard': {
               #                  'total_number': 3360,
               #                  'train_number': 132524,
               #                  'test_number': 7362,
               #                  'validation_number': 7362,
               #                  'mu': 34.66,
               #                  'var': 4576.08, # std -> 20940545.79
               #                  'audio_path_train': '/data1/fatemeh/BC2013_16khz_splited/train/',
               #                  'audio_path_test': '/data1/fatemeh/BC2013_16khz_splited/test/',
               #                  'audio_path_validation': '/data1/fatemeh/BC2013_16khz_splited/validation/',
               #                  'pkl_path': '/data1/fatemeh/BC2013_16khz_splited/{}.pkl',
               #                  # 'save_path_model': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pt',
               #                  # 'save_path_results': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pkl'}
               #                  'save_path_model': '/hdd4/fatemeh/paper/models/{}_{}.pt',
               #                  'save_path_results': '/hdd4/fatemeh/paper/logs/{}_{}.pkl'}
                'blizzard': {
                    'total_number': (57223 + 3180 + 3180),
                    'train_number': 57223,
                    'test_number': 3180,
                    'validation_number': 3180,
                    'mu': 86.06,
                    'var': 4322.41,
                    'audio_path_train': '/data2/fatemeh/Blizzard/BC2013_16khz_splited_v0_wav2/train/',
                    'audio_path_test': '/data2/fatemeh/Blizzard/BC2013_16khz_splited_v0_wav2/test/',
                    'audio_path_validation': '/data2/fatemeh/Blizzard/BC2013_16khz_splited_v0_wav2/validation/',
                    'pkl_path': '/data2/fatemeh/Blizzard/BC2013_16khz_splited_v0_wav2/{}.pkl',
                    'save_path_model': '/hdd3/fatemeh/thesis/Blizzard/models/{}_{}.pt',
                    'save_path_results': '/hdd3/fatemeh/thesis/Blizzard/logs/{}_{}.pkl'}
    }
else: # 139
    info = {'accent': {'total_number': 2921,
                       'train_number': 2628,
                       'test_number': 146,
                       'validation_number': 146,
                       'mu': 0.24,  # 0.25, #-0.99 for only 16
                       'var': 962.28,  # 957.05, #957.05, #2445.26 for only 16  # std
                       #  'mu': -0.99, # for only 16
                       # 'var': 2445.26, #for only 16  # std
                       'audio_path_train': '/data1/fatemeh/thesis/ACCENT/output16/train/',
                       'audio_path_test': '/data1/fatemeh/thesis/ACCENT/output16/test/',
                       'audio_path_validation': '/data1/fatemeh/thesis/ACCENT/output16/validation/',
                       'pkl_path': '/data1/fatemeh/thesis/ACCENT/output16/{}.pkl',
                       # 'save_path_model': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pt',
                       # 'save_path_results': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pkl'},
                       'save_path_model': '/data1/fatemeh/thesis/ACCENT/models/{}_{}.pt',
                       'save_path_results': '/data1/fatemeh/thesis/ACCENT/logs/{}_{}.pkl'},
            'timit': {'total_number': 3360,
                      'train_number': 1680,
                      'test_number': 1680,
                      'validation_number': 1680,
                      'mu': -0.0045,
                      'var': 526.25,
                      'audio_path_train': '/data1/fatemeh/thesis/TIMIT/data/timit-train/',
                      'audio_path_test': '/data1/fatemeh/thesis/TIMIT/data/timit-test/',
                      'audio_path_validation': '/data1/fatemeh/thesis/TIMIT/data/timit-test',
                      'pkl_path': '/data1/fatemeh/thesis/TIMIT/data/timit-{}.pkl',
                      # 'save_path_model': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pt',
                      # 'save_path_results': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pkl'}
                      'save_path_model': '/data1/fatemeh/thesis/TIMIT/models/{}_{}.pt',
                      'save_path_results': '/data1/fatemeh/thesis/TIMIT/logs/{}_{}.pkl'},
            # 'blizzard': {
            #     'total_number': 3360,
            #     'train_number': 132524,
            #     'test_number': 7362,
            #     'validation_number': 7362,
            #     'mu': 34.66,
            #     'var': 4576.08,  # std -> 20940545.79
            #     'audio_path_train': '/data1/fatemeh/thesis/Blizzard/BC2013_16khz_splited/train/',
            #     'audio_path_test': '/data1/fatemeh/thesis/Blizzard/BC2013_16khz_splited/test/',
            #     'audio_path_validation': '/data1/fatemeh/thesis/Blizzard/BC2013_16khz_splited/validation/',
            #     'pkl_path': '/data1/fatemeh/thesis/Blizzard/BC2013_16khz_splited/{}.pkl',
            #     # 'save_path_model': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pt',
            #     # 'save_path_results': '/hdd2/fatemeh/VRNN1/logs_accent/{}_{}.pkl'}
            #     'save_path_model': '/data1/fatemeh/thesis/Blizzard/models/{}_{}.pt',
            #     'save_path_results': '/data1/fatemeh/thesis/Blizzard/logs/{}_{}.pkl'}
            'blizzard': {
                'total_number': (57223 + 3180 + 3180),
                'train_number': 57223,
                'test_number': 3180,
                'validation_number': 3180,
                'mu': 86.06,
                'var': 4322.41,
                'audio_path_train': '/data1/fatemeh/thesis/Blizzard/BC2013_16khz_splited_v0_wav2/train/',
                'audio_path_test': '/data1/fatemeh/thesis/Blizzard/BC2013_16khz_splited_v0_wav2/test/',
                'audio_path_validation': '/data1/fatemeh/thesis/Blizzard/BC2013_16khz_splited_v0_wav2/validation/',
                'pkl_path': '/data1/fatemeh/thesis/Blizzard/BC2013_16khz_splited_v0_wav2/{}.pkl',
                'save_path_model': '/data1/fatemeh/thesis/Blizzard/models/{}_{}.pt',
                'save_path_results': '/data1/fatemeh/thesis/Blizzard/logs/{}_{}.pkl'}
            }

# def main():
# CUDA_VISIBLE_DEVICES=3 python3 main.py - -E = 50 - -LR = 0.001 - -K = 20 - -F = True - -COV = simple
# CUDA_VISIBLE_DEVICES=3 python3 main.py --F no --COV simple
# CUDA_VISIBLE_DEVICES=3 python3 main.py --F yes --COV simple
# CUDA_VISIBLE_DEVICES=3 python3 main.py --F no --COV output
# CUDA_VISIBLE_DEVICES=3 python3 main.py --F yes --COV output
# CUDA_VISIBLE_DEVICES=3 python3 main.py --F no --COV direct
# CUDA_VISIBLE_DEVICES=3 python3 main.py --F yes --COV direct
# cd /hdd2/fatemeh/VRNN1/v4_decomposition
# source /hdd2/fatemeh/env/bin/activate

parser = argparse.ArgumentParser("Thesis")

parser.add_argument('--G', type=int, default=0, help="gpu number: 0, 1, 2, or 3")
parser.add_argument('--E', type=int, default=10000, help="epoch number")
parser.add_argument('--LR', type=float, default=0.0003, help="learning rate")
parser.add_argument('--B', type=int, default=128, help="batch size")
# parser.add_argument('--C', type=bool, default=True, action='store_false', help="do clip")
# parser.add_argument('--C', default=True, action='store_false', help="do clip")
parser.add_argument('--C', type=str, default="no", help="do clip")
parser.add_argument('--CL', type=float, default=1., help="clip value")
# parser.add_argument('--No', type=bool, default=False, action='store_true', help="make noise")
parser.add_argument('--No', type=str, default="no", help="make noise")
# parser.add_argument('--No', default=False, action='store_true', help="make noise")

parser.add_argument('--H', type=int, default=4000, help="hidden size (lstm)")
parser.add_argument('--L', type=int, default=1, help="layer number (lstm)")
parser.add_argument('--Op', type=str, default="adam", help="optimizer")

parser.add_argument('--AC', type=str, default="softplus", help="activation function for the variance")
parser.add_argument('--PA', type=float, default=0.0001, help="addtitive value to the variance")

parser.add_argument('--K', type=int, default=20, help="component number (gmm)")
parser.add_argument('--BL', type=int, default=2, help="block number (flow)")
# parser.add_argument('--S', type=str, default=True, help="separate matrix U when S is True")
parser.add_argument('--Dprim', type=int, default=1, help="second dimension of U")
# parser.add_argument('--F', type=bool, default=True, action='store_false', help="with or without flow")
parser.add_argument('--F', type=str, default="no", help="with or without flow")
# parser.add_argument('--F', default=True, action='store_false', help="with or without flow")
parser.add_argument('--COV', type=str, default="simple", help="simple, output, direct")

parser.add_argument('--X', type=int, default=200, help="input size")
parser.add_argument('--Y', type=int, default=200, help="output size")

parser.add_argument('--N', type=str, default="blizzard", help="data name")
parser.add_argument('--R', type=str, default="no", help="resume or not")
parser.add_argument('--M', type=str, default="/data1/fatemeh/thesis/Blizzard/models/blizzard_flow_False_cov_direct_dprim_2_activation_softplus_parameter_0.0001_hdim_4000_layer_1_epoch_10000_lr_0.0003_batch_128_K_20_block_2_doclip_False_clip_1.0_noise_False_opt_adam.pt", help="checkpoint path")

args = parser.parse_args()

hp = Hyperparameter(args)

print("\n")
print(hp.setting)
print("\n")

if (hp.do_flow):    # FRMDN
    model = FRMDN(hp=hp).flow_based
    model = model.to(hp.device)
else:   # RMDN
    if (hp.cov_type == "simple"):
        model = RMDNSimple(hp=hp).to(hp.device)
    elif (hp.cov_type == "output"):
        model = RMDN_Uout(hp=hp).to(hp.device)
    else:
        model = RMDN_Udirect(hp=hp).to(hp.device)
if (args.R =="yes"):
    model = torch.load(args.M).to(hp.device)

print(args.N)

for name, param in model.named_parameters():
    if param.requires_grad:
        print(name, param.data.shape)


from functools import partial

class EarlyStopping(object): # pylint: disable=R0902
    """
    Gives a criterion to stop training when a given metric is not
    improving anymore
    Args:
        mode (str): One of `min`, `max`. In `min` mode, training will
            be stopped when the quantity monitored has stopped
            decreasing; in `max` mode it will be stopped when the
            quantity monitored has stopped increasing. Default: 'min'.
        patience (int): Number of epochs with no improvement after
            which training is stopped. For example, if
            `patience = 2`, then we will ignore the first 2 epochs
            with no improvement, and will only stop learning after the
            3rd epoch if the loss still hasn't improved then.
            Default: 10.
        threshold (float): Threshold for measuring the new optimum,
            to only focus on significant changes. Default: 1e-4.
        threshold_mode (str): One of `rel`, `abs`. In `rel` mode,
            dynamic_threshold = best * ( 1 + threshold ) in 'max'
            mode or best * ( 1 - threshold ) in `min` mode.
            In `abs` mode, dynamic_threshold = best + threshold in
            `max` mode or best - threshold in `min` mode. Default: 'rel'.
    """

    def __init__(self, mode='min', patience=10, threshold=1e-4, threshold_mode='rel'):
        self.patience = patience
        self.mode = mode
        self.threshold = threshold
        self.threshold_mode = threshold_mode
        self.best = None
        self.num_bad_epochs = None
        self.mode_worse = None  # the worse value for the chosen mode
        self.is_better = None
        self.last_epoch = -1
        self._init_is_better(mode=mode, threshold=threshold,
                             threshold_mode=threshold_mode)
        self._reset()

    def _reset(self):
        """Resets num_bad_epochs counter and cooldown counter."""
        self.best = self.mode_worse
        self.num_bad_epochs = 0

    def step(self, metrics, epoch=None):
        """ Updates early stopping state """
        current = metrics
        if epoch is None:
            epoch = self.last_epoch = self.last_epoch + 1
        self.last_epoch = epoch

        if self.is_better(current, self.best):
            self.best = current
            self.num_bad_epochs = 0
        else:
            self.num_bad_epochs += 1

    @property
    def stop(self):
        """ Should we stop learning? """
        return self.num_bad_epochs > self.patience


    def _cmp(self, mode, threshold_mode, threshold, a, best): # pylint: disable=R0913, R0201
        if mode == 'min' and threshold_mode == 'rel':
            rel_epsilon = 1. - threshold
            return a < best * rel_epsilon

        elif mode == 'min' and threshold_mode == 'abs':
            return a < best - threshold

        elif mode == 'max' and threshold_mode == 'rel':
            rel_epsilon = threshold + 1.
            return a > best * rel_epsilon

        return a > best + threshold

    def _init_is_better(self, mode, threshold, threshold_mode):
        if mode not in {'min', 'max'}:
            raise ValueError('mode ' + mode + ' is unknown!')
        if threshold_mode not in {'rel', 'abs'}:
            raise ValueError('threshold mode ' + threshold_mode + ' is unknown!')

        if mode == 'min':
            self.mode_worse = float('inf')
        else:  # mode == 'max':
            self.mode_worse = (-float('inf'))

        self.is_better = partial(self._cmp, mode, threshold_mode, threshold)

    def state_dict(self):
        """ Returns early stopping state """
        return {key: value for key, value in self.__dict__.items() if key != 'is_better'}

    def load_state_dict(self, state_dict):
        """ Loads early stopping state """
        self.__dict__.update(state_dict)
        self._init_is_better(mode=self.mode, threshold=self.threshold,
                             threshold_mode=self.threshold_mode)

earlystopping = EarlyStopping('min', patience=20, threshold=100, threshold_mode="abs")

if (args.Op == "adam"):
    optimizer = torch.optim.Adam(list(model.parameters()), lr=hp.learning_rate)
else:
    optimizer = torch.optim.RMSprop(list(model.parameters()), lr=hp.learning_rate)
    # optimizer = getOptim(lr=hp.learning_rate)
# optimizer = torch.optim.SGD(list(model.parameters()), lr=hp.learning_rate)


results = {'gmm_epoch_train': [],
           'logdet_epoch_train': [],
           'loss_epoch_train': [],
           'gmm_iter_train': [],
           'logdet_iter_train': [],
           'loss_iter_train': [],
           ############
           'gmm_epoch_test': [],
           'logdet_epoch_test': [],
           'loss_epoch_test': [],
           'gmm_iter_test': [],
           'logdet_iter_test': [],
           'loss_iter_test': [],
            ############
           'gmm_epoch_validation': [],
           'logdet_epoch_validation': [],
           'loss_epoch_validation': [],
           'gmm_iter_validation': [],
           'logdet_iter_validation': [],
           'loss_iter_validation': []
           }

DataTrain = DataLoader(hp, info, 'train')
DataTest = DataLoader(hp, info, 'test')
if (args.N == "timit"):
    DataValidation= DataLoader(hp, info, 'test') #TODO
else:
    DataValidation= DataLoader(hp, info, 'validation')
for epoch in range(1, hp.n_epochs + 1):

    network = model

    for kind in ['train', 'test', 'validation']:

        # if (kind == "validation"):
        #     continue

        max_iteration = info[hp.name]['{}_number'.format(kind)] // 1

        L, G, D = 0, 0, 0
        Batch_loss_iter,  Batch_gmm_iter, Batch_logdet_iter = 0, 0, 0
        count = 0

        for iter in range(max_iteration):

            if (kind == 'train'):
                batch = DataTrain.next_batch()  # batch = {'audio': audio, 'names': names, 'len': len}
                if (iter == 0) or (iter % hp.batch_size == 0):
                    BatchLoss = torch.zeros(1).to(hp.device)
                    # BatchLoss = torch.zeros(hp.batch_size).to(hp.device)
                    optimizer.zero_grad()
            elif (kind == "test"):
                batch = DataTest.next_batch()  # batch = {'audio': audio, 'names': names, 'len': len}
                if (iter == 0) or (iter % hp.batch_size == 1):
                    BatchLoss = torch.zeros(1).to(hp.device)
                    # BatchLoss = torch.zeros(hp.batch_size).to(hp.device)
            else:
                batch = DataValidation.next_batch()  # batch = {'audio': audio, 'names': names, 'len': len}
                if (iter == 0) or (iter % hp.batch_size == 1):
                    BatchLoss = torch.zeros(1).to(hp.device)
                    # BatchLoss = torch.zeros(hp.batch_size).to(hp.device)

            current_batch = torch.from_numpy(batch['audio']).type(torch.FloatTensor).to(hp.device)
            if (current_batch.shape[1] <= 1):
                continue
            #print(current_batch.shape)

            if (hp.do_flow):
                zs, prior_logprob, log_det = model(current_batch)
                logprob = - (prior_logprob + log_det)
                BatchLoss += logprob
                # BatchLoss[count] = logprob
            else:
                # mu, D, logpi = model(current_batch[:, :-1, :])
                if (hp.cov_type == "simple"):
                    mu, D, logpi = model(current_batch[:, :-1, :])
                    prior_logprob = gmm(current_batch[:, 1:, :], mu, D, logpi, hp)
                else:
                    mu, D, logpi, U = model(current_batch[:, :-1, :])
                    prior_logprob = gmm_Uout(current_batch[:, 1:, :], mu, D, logpi, U, hp)
                    # prior_logprob = gmm_loss(current_batch[:, 1:, :], mu, D, logpi, U, hp)
                # mu, D, logpi = model(current_batch[:, :10, :])
                # prior_logprob = gmm(current_batch[:, 1:11 :], mu, D, logpi, hp)
                # mu, D, logpi = model(current_batch[:, :, :])
                # prior_logprob = gmm(current_batch[:, :, :], mu, D, logpi, hp)

                # l2_reg = torch.tensor(0.).to(hp.device)
                # for param in model.parameters():
                #     l2_reg += torch.norm(param)

                logprob = - prior_logprob
                log_det = torch.zeros(1).to(hp.device)
                # BatchLoss += logprob
                BatchLoss += logprob # prior_logprob # + (0.1 * l2_reg)
                # BatchLoss[count] = logprob

            loss_iter = round(logprob.item(), 2)
            gmm_iter = - round(prior_logprob.item(), 2)
            logdet_iter = - round(log_det.item(), 2)

            Batch_loss_iter += loss_iter
            Batch_gmm_iter += gmm_iter
            Batch_logdet_iter += logdet_iter

            if (kind == 'train'):
                if (iter % hp.batch_size == 0):
                    # BatchLoss = torch.mean(BatchLoss)
                    BatchLoss.backward()
                    #if (hp.do_clip):
                    #    torch.nn.utils.clip_grad_norm(model.parameters(), hp.clip)
                    optimizer.step()

                    print("kind = {}, epoch = {}, iter = {}, L = {}, G = {}, D = {}".format(kind, epoch, iter,
                        round(Batch_loss_iter / hp.batch_size, 2),
                         round(Batch_gmm_iter / hp.batch_size, 2),
                         round(Batch_logdet_iter / hp.batch_size, 2)))

                    del BatchLoss
                    BatchLoss = torch.zeros(1).to(hp.device)
                    # BatchLoss = torch.zeros(hp.batch_size).to(hp.device)
                    # BatchLoss = torch.zeros(hp.batch_size + 1).to(hp.device)

                    L += (Batch_loss_iter / hp.batch_size)
                    G += (Batch_gmm_iter / hp.batch_size)
                    D += (Batch_logdet_iter / hp.batch_size)

                    Batch_loss_iter = 0
                    Batch_gmm_iter = 0
                    Batch_logdet_iter = 0

                    count += 1

            if ((kind == 'test')): # or (kind == "validation")):
                if (iter % hp.batch_size == 0):
                    print("kind = {}, epoch = {}, iter = {}, L = {}, G = {}, D = {}".format(kind, epoch, iter,
                                                                                            Batch_loss_iter / hp.batch_size,
                                                                                            Batch_gmm_iter / hp.batch_size,
                                                                                            Batch_logdet_iter / hp.batch_size))

                    del BatchLoss
                    # BatchLoss = torch.zeros(1)
                    # BatchLoss = torch.zeros(hp.batch_size + 1).to(hp.device)

                    L += (Batch_loss_iter / hp.batch_size)
                    G += (Batch_gmm_iter / hp.batch_size)
                    D += (Batch_logdet_iter / hp.batch_size)

                    Batch_loss_iter = 0
                    Batch_gmm_iter = 0
                    Batch_logdet_iter = 0

                    count += 1
        
        # print("L = ", L)
        # print("count = ", count)
        results['loss_epoch_{}'.format(kind)].append(L / count)  # (max_iteration // hp.batch_loss))
        results['gmm_epoch_{}'.format(kind)].append(G / count)  # (max_iteration // hp.batch_loss))
        results['logdet_epoch_{}'.format(kind)].append(D / count)  # (max_iteration // hp.batch_loss))

        if (kind == "validation"):
            earlystopping.step(results['loss_epoch_validation'][-1])

        if ((L / count) <= min(results['loss_epoch_{}'.format(kind)])):
            torch.save(network, info[hp.name]['save_path_model'].format(hp.name, hp.setting))

    file = open(info[hp.name]['save_path_results'].format(hp.name, hp.setting), "wb")
    pickle.dump(results, file)
    file.close()

    #if (args.F == "yes") and (earlystopping.stop):
    #    print("End of Training because of early stopping at epoch {}".format(epoch))
    #    break