import torch
import torch.nn as nn
import torch.nn.functional as f
import numpy as np
import math
from torch.distributions.multivariate_normal import MultivariateNormal

# class _RMDNBase(nn.Module):
#     def __init__(self, hp, separateU):
#         # hp: hyper-parameters define in main function
#         # separateU indicates U is the output of the neural network or not
#         # separateU=True => U is not the output of the neural network
#         # separateU=False => U is the output of the neural network
#         super().__init__()
#         self.dprim = hp.dprim
#         dprim = hp.dprim
#         if (separateU == True):
#             self.U = torch.rand((hp.gaussians, hp.y_dim, self.dprim), requires_grad=False).to(hp.device)
#             self.U = self.U[None, None, :, :, :]
#             dprim = 0
#         self.gmm_linear = nn.Linear(hp.h_dim, (2*hp.y_dim + 1 + hp.y_dim*dprim) * hp.gaussians, bias=True)
#     def forward(self, *inputs):
#         pass

# class RMDN(_RMDNBase):
#     def __init__(self, hp, separateU):
#         # hp: hyper-parameters define in main function
#         # separateU indicates U is the output of the neural network or not
#         # separateU=True => U is not the output of the neural network
#         # separateU=False => U is the output of the neural network
#         # dprim is the second dimension of U
#         super().__init__(hp, separateU)
#         self.rnn = nn.LSTM(input_size=hp.x_dim, hidden_size=hp.h_dim, num_layers=hp.n_layers, batch_first=True, bias=True)#.flatten_parameters()
#         self.hp = hp
#         self.separateU = separateU
#         self.dprim = hp.dprim
#
#     def forward(self, inputs):
#         # inputs => [Batch, sequence length, x_dim]
#         # outs => [Batch, sequence length, h_dim]
#         # gmm_outs => [Batch, sequence length, parameters size]
#
#         # print("^^^^^^^^^^^^^^^^^^^^^^^^^^^")
#         # print(inputs.shape)
#
#         outs, _ = self.rnn(inputs)
#         # print("%%%%%%%%%%%%%%%%%%%")
#         gmm_outs = self.gmm_linear(outs)
#         # print("##################", gmm_outs.shape)
#
#         stride = self.hp.gaussians * self.hp.y_dim
#
#         # print("stride = ", stride)
#
#         mu = gmm_outs[:, :, :stride]
#         # print("mu = ", mu.shape)
#         # mu = mu.view(self.hp.batch_size, self.hp.gaussians, self.hp.y_dim)
#         mu = mu.view(1, -1, self.hp.gaussians, self.hp.y_dim)
#         # mu => [Batch, sequence length, gaussian, y_dim]
#
#         D = gmm_outs[:, :, stride: 2 * stride]
#         # print("D = ", D.shape)
#         # D = D.view(self.hp.batch_size, -1, self.hp.gaussians, self.hp.y_dim)
#         D = D.view(1, -1, self.hp.gaussians, self.hp.y_dim)
#         D = torch.clamp(torch.sqrt(torch.exp(D)), min=0.1, max=1.9)
#         # D => [Batch, sequence length, gaussian, y_dim]
#
#         pi = gmm_outs[:, :, 2 * stride:2 * stride +self.hp.gaussians]
#         # pi = pi.view(self.hp.batch_size, -1, self.hp.gaussians)
#         pi = pi.view(1, -1, self.hp.gaussians)
#         logpi = f.log_softmax(pi, dim=-1)
#         # logpi => [Batch, sequence length, gaussian]
#
#         if (self.separateU == False):
#             U = gmm_outs[:, :, 2 * stride +self.hp.gaussians:]
#             # self.U = U.view(self.hp.batch_size, -1, self.hp.gaussians, self.hp.y_dim, self.dprim)
#             self.U = U.view(1, -1, self.hp.gaussians, self.hp.y_dim, self.dprim)
#             # U => [Batch, sequence length, gaussian, y_dim, dprim]
#
#         # print("\nsigmas = ", torch.min(sigmas).item(), torch.mean(sigmas).item(), torch.max(sigmas).item())
#         # print("mus = ", torch.min(mus).item(), torch.mean(mus).item(), torch.max(mus).item())
#         # print("logpi = ", torch.min(logpi).item(), torch.mean(logpi).item(), torch.max(logpi).item(), "\n")
#         # print(mu.shape, D.shape, logpi.shape, self.U.shape)
#         # print("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&")
#         return mu, D, logpi, self.U
#
#     def log_prob(self, batch, mu, D, logpi, U):
#         # batch => [Batch, sequence length, y_dim]
#         # mu => [Batch, sequence length, gaussian, y_dim]
#         # D => [Batch, sequence length, gaussian, y_dim]
#         # logpi => [Batch, sequence length, gaussian]
#         # U => [Batch, sequence length, gaussian, y_dim, dprim]
#
#         batch = batch[:, :, None, :]
#
#         d = U.shape[-2]
#         dprim = U.shape[-1]
#
#         Y = batch - mu
#
#         V = Y * torch.sqrt(D)
#         VVtranspose = torch.sum(V * V, -1)
#
#         Y = Y[:, :, :, None, :]
#         Z = Y @ U
#         ZZtranspose = torch.sum(Z * Z, -1).squeeze()
#
#         exp_term = -0.5 * (VVtranspose + ZZtranspose)
#         const_term = -(d / 2) * np.log(2 * math.pi)
#
#         Dinverse = torch.div(1, torch.sqrt(D))[:, :, :, None, :]
#         Utranspose = torch.transpose(U, -2, -1)
#         UDinverse = Dinverse * Utranspose
#         UDinverseTranspose = torch.transpose(UDinverse, -2, -1)
#         UDU = torch.eye(dprim).to(self.hp.device)[None, None, None, :, :] + (UDinverse @ UDinverseTranspose)
#         det1 = torch.logdet(UDU)
#
#         # # print(Dinverse.shape, Utranspose.shape, "%%%%%%%%%%%%")
#         # # print(torch.transpose(Utranspose, -2, -1).shape, "~~~~~~~~~~~~~~~~~~~~~~~~~", Dinverse.shape)
#         # UDinverseU = Dinverse * torch.transpose(Utranspose, -2, -1)
#         # term2 = UDinverseU @ torch.transpose(UDinverseU, -2, -1)
#         # print("\n", UDinverseU.shape, term2.shape, "\n")
#         #
#         # print("!!!!!!!!!!!!!!!!!!!!!!!!!! ", U.shape)
#         # print(torch.transpose(U, -2, -1).shape)
#         # print(torch.div(1, torch.sqrt(D)).shape, "&&&&&&&&&&&&&&&&&&&&&")
#         # # b = torch.transpose(U, -2, -1) @ torch.div(1, torch.sqrt(D))
#         # # print("BBBBBBBBBBBB", b.shape)
#         # P = torch.transpose(U, -2, -1) @ torch.div(1, torch.sqrt(D))[:, :, :, :, None]
#         # print("PPPPPPPPPPPPPPPPP ", P.shape)
#         # XX = P*P
#         # print("XX ========= ", XX.shape)
#         # PPtranspose = torch.sum(P * P, -1)
#         # print("PPPPPPPPPPPPPPPPP ", PPtranspose.shape)
#         #
#         # print("*************************")
#         # print(self.separateU, self.U.shape)
#         # # print(dprim, torch.eye(dprim).shape)
#         # print("/\/\/\/\/\/\/\/")
#         # print(torch.eye(dprim)[None, None, None, :, :].shape)
#         # print(PPtranspose.shape)
#         # print("*************************")
#         # print("######", torch.eye(dprim).shape)
#         # a = torch.eye(dprim)[None, None, None, :, :]
#         # print("######", a.shape)
#         #
#         det2 = torch.sum(torch.log(D), -1)
#         # print("$$$$$$$$$$$$", det2.shape)
#         #
#         # det1 = torch.logdet(torch.eye(dprim)[None, None, None, :, :] + PPtranspose)
#         # det1 = det2
#
#         log_gmm = logpi - const_term + 0.5 * (det1 + det2) + exp_term
#         log_sum_exp = torch.logsumexp(log_gmm, -1)
#         sum_over_sequence_length = torch.sum(log_sum_exp, -1) - np.log(log_sum_exp.shape[-1])
#         # mean_over_batches = torch.mean(sum_over_sequence_length)
#         mean_over_batches = torch.sum(sum_over_sequence_length)
#
#         return mean_over_batches

class MLP(nn.Module):
    def __init__(self, nin, nout, nh):
        super().__init__()
        self.net = nn.Sequential(
            nn.Linear(nin, nh, bias=False),
            # nn.Relu(),
            nn.LeakyReLU(0.2),
            nn.Linear(nh, nh),
            nn.LeakyReLU(0.2),
            nn.Linear(nh, nh),
            nn.LeakyReLU(0.2),
            nn.Linear(nh, nout, bias=False),
        )
    def forward(self, x):
        return self.net(x)

class AffineHalfFlow(nn.Module):
    def __init__(self, dim, parity, net_class=MLP, nh=24, scale=True, shift=True):
        super().__init__()
        self.dim = dim
        self.parity = parity
        self.s_cond = lambda x: x.new_zeros(x.size(0), self.dim // 2)
        self.t_cond = lambda x: x.new_zeros(x.size(0), self.dim // 2)
        if scale:
            self.s_cond = net_class(self.dim // 2, self.dim // 2, nh)
        if shift:
            self.t_cond = net_class(self.dim // 2, self.dim // 2, nh)

    def forward(self, x):
        x0, x1 = x[:, :, ::2], x[:, :, 1::2] # (x0, x1 = x[:, ::2], x[:, 1::2]) 2D -> 3D
        if self.parity:
            x0, x1 = x1, x0
        s = self.s_cond(x0)
        t = self.t_cond(x0)
        z0 = x0  # untouched half
        z1 = torch.exp(s) * x1 + t  # transform this half as a function of the other
        if self.parity:
            z0, z1 = z1, z0
        z = torch.cat([z0, z1], dim=2) # (z = torch.cat([z0, z1], dim=1)) 2D -> 3D
        log_det = torch.sum(s, dim=[1,2]) # (log_det = torch.sum(s, dim=1)) 2D -> 3D
        return z, log_det

    def backward(self, z):
        z0, z1 = z[:, :, ::2], z[:, :, 1::2] ## (z0, z1 = z[:, ::2], z[:, 1::2]) 2D -> 3D
        if self.parity:
            z0, z1 = z1, z0
        s = self.s_cond(z0)
        t = self.t_cond(z0)
        x0 = z0  # this was the same
        x1 = (z1 - t) * torch.exp(-s)  # reverse the transform on this half
        if self.parity:
            x0, x1 = x1, x0
        # x = torch.cat([x0, x1], dim=1)
        # log_det = torch.sum(-s, dim=1)
        x = torch.cat([x0, x1], dim=2)  # (z = torch.cat([z0, z1], dim=1)) 2D -> 3D
        log_det = torch.sum(-s, dim=[1,2])  # (log_det = torch.sum(s, dim=1)) 2D -> 3D
        return x, log_det

class NormalizingFlow(nn.Module):

    def __init__(self, hp, flows):
        super().__init__()
        self.hp = hp
        self.flows = nn.ModuleList(flows)

    def forward(self, x):
        m, _, _ = x.shape   ## (m, _ = x.shape) 2D -> 3D
        log_det = torch.zeros(m).to(self.hp.device)
        zs = [x]
        for flow in self.flows:
            x, ld = flow.forward(x)
            log_det += ld
            zs.append(x)
        return zs, log_det

    def backward(self, z):
        m, _, _ = z.shape   ## (m, _ = x.shape) 2D -> 3D
        log_det = torch.zeros(m).to(self.hp.device)
        xs = [z]
        for flow in self.flows[::-1]:
            z, ld = flow.backward(z)
            log_det += ld
            xs.append(z)
        return xs, log_det

class NormalizingFlowModel(nn.Module):
    def __init__(self, hp, prior, flows,):
        super().__init__()
        self.prior = prior
        #self.prior = MultivariateNormal(torch.zeros(hp.y_dim).to(hp.device), torch.eye(hp.y_dim).to(hp.device))
        self.flow = NormalizingFlow(hp, flows)
        self.hp = hp

    def forward(self, x):
        zs, log_det = self.flow.forward(x[:, 1:, :])
        if (self.hp.cov_type == "simple"):
            mu, D, logpi = self.prior(x[:, :-1, :])  # RMDN pass
            prior_logprob = gmm(zs[-1], mu, D, logpi, self.hp)
        else:
            mu, D, logpi, U = self.prior(x[:, :-1, :])  # RMDN pass
            prior_logprob = gmm_Uout(zs[-1], mu, D, logpi, U, self.hp)
        #self.prior = MultivariateNormal(torch.zeros(hp.y_dim), torch.eye(hp.y_dim))
        #prior_logprob = self.prior.log_prob(zs[-1]).sum(1)
        return zs, prior_logprob, log_det

    def backward(self, z):
        xs, log_det = self.flow.backward(z)
        return xs, log_det

    def sample(self, num_samples):
        z = self.prior.sample((num_samples,)) # TODO: extend to GMM case.
        xs, _ = self.flow.backward(z)
        return xs

class FRMDN(object):
    def __init__(self, hp):
        self.flows = [AffineHalfFlow(dim=hp.y_dim, parity=i % 2) for i in range(hp.n_block)]
        if (hp.cov_type == "simple"):
            self.prior = RMDNSimple(hp)
        elif (hp.cov_type == "output"):
            self.prior = RMDN_Uout(hp)
        else:
            self.prior = RMDN_Udirect(hp)
        self.flow_based = NormalizingFlowModel(hp, self.prior, self.flows)

from torch.distributions.normal import Normal
import numpy as np
import math
def gmm(batch, mu, D, logpi, hp):
        # # batch => [Batch, sequence length, y_dim]
        # # mu => [Batch, sequence length, gaussian, y_dim]
        # # D => [Batch, sequence length, gaussian, y_dim]
        # # logpi => [Batch, sequence length, gaussian]
        # # U => [Batch, sequence length, gaussian, y_dim, dprim]
        batch = batch[:, :, None, :]
        g_log_probs = - torch.log(D) - (0.5) * (np.log(2*math.pi)) - (0.5) * (((batch - mu) / D) ** 2)
        g_log_probs = logpi + torch.sum(g_log_probs, dim=-1)
        # max_log_probs = torch.max(g_log_probs, dim=-1, keepdim=True)[0]
        # g_log_probs = g_log_probs - max_log_probs
        # g_probs = torch.exp(g_log_probs)
        # probs = torch.sum(g_probs, dim=-1)
        # # log_prob = max_log_probs.squeeze() + torch.log(probs)
        # log_prob = torch.log(probs)
        log_prob = torch.logsumexp(g_log_probs, -1)
        # if (reduce == True):
        return torch.sum(log_prob)
        # else:
        #     return log_prob


from torch.distributions.lowrank_multivariate_normal import LowRankMultivariateNormal
def gmm_Uout_library(batch, mu, D, logpi, U, hp):
    # # batch => [Batch, sequence length, y_dim]
    # # mu => [Batch, sequence length, gaussian, y_dim]
    # # D => [Batch, sequence length, gaussian, y_dim]
    # # logpi => [Batch, sequence length, gaussian]
    # # U => [Batch, sequence length, gaussian, y_dim, dprim]
    batch = batch[:, :, None, :]
    batch = batch.repeat(1,1,hp.gaussians,1)#.unsqueeze(-2)
    # U = self.U.repeat(mu.shape[1], 1, 1, 1).unsqueeze(0)
    # cov_diag = torch.diag_embed(D)
    # torch.Size([1, 39, 20, 1, 200])
    # torch.Size([1, 39, 20, 200])
    # torch.Size([1, 39, 20, 200])
    # torch.Size([1, 39, 20])
    # torch.Size([1, 39, 20, 200, 1])
    # torch.Size([1, 39, 20, 200, 200])

    normal_dist = LowRankMultivariateNormal(mu, U, D)
    g_log_probs = normal_dist.log_prob(batch)
    # log_gmm = logpi + torch.sum(g_log_probs, dim=-1)
    log_gmm = torch.add(logpi, g_log_probs)
    log_sum_exp = torch.logsumexp(log_gmm, -1)
    sum_over_sequence_length = torch.sum(log_sum_exp, -1)
    sum_over_batches = torch.sum(sum_over_sequence_length)
    return sum_over_batches


def gmm_Uout(batch, mu, D, logpi, U, hp):
    # # batch => [Batch, sequence length, y_dim]
    # # mu => [Batch, sequence length, gaussian, y_dim]
    # # D => [Batch, sequence length, gaussian, y_dim]
    # # logpi => [Batch, sequence length, gaussian]
    # # U => [Batch, sequence length, gaussian, y_dim, dprim]

    batch = batch[:, :, None, :]
    batch = batch.repeat(1, 1, hp.gaussians, 1)  # .unsqueeze(-2)

    b = U.shape[0]
    T = U.shape[1]
    K = U.shape[2]

    d = U.shape[-2]
    dprim = U.shape[-1]

    Y = batch - mu

    YD = torch.pow(Y * torch.sqrt(D), 2)
    YDY = torch.sum(YD, -1)

    Y = Y[:, :, :, None, :]
    # Y = Y.repeat(1, 1, 1, d, 1)

    YU = Y @ U
    YUUY = YU @ YU.transpose(-2, -1)

    exp_term = -0.5 * (YDY + YUUY.squeeze())
    const_term = -(d / 2) * np.log(2 * math.pi)

    Dinverse = torch.div(1, torch.sqrt(D))[:, :, :, None, :]
    Dinverse = Dinverse.repeat(1, 1, 1, dprim, 1)
    Utranspose = torch.transpose(U, -2, -1)
    UDinverse = Utranspose * Dinverse
    UDinverseTranspose = torch.transpose(UDinverse, -2, -1)
    UDU = torch.eye(dprim).to(hp.device)[None, None, None, :, :].repeat(b, T, K, 1, 1) + (UDinverse @ UDinverseTranspose)
    det1 = torch.logdet(UDU)
    det2 = torch.sum(torch.log(D), -1)

    log_gmm = logpi + const_term + 0.5 * (det1 + det2) + exp_term

    log_sum_exp = torch.logsumexp(log_gmm, -1)
    sum_over_sequence_length = torch.sum(log_sum_exp, -1)
    sum_over_batches = torch.sum(sum_over_sequence_length)

    return sum_over_batches

def gmm_Uout_old(batch, mu, D, logpi, U, hp):
    # # batch => [Batch, sequence length, y_dim]
    # # mu => [Batch, sequence length, gaussian, y_dim]
    # # D => [Batch, sequence length, gaussian, y_dim]
    # # logpi => [Batch, sequence length, gaussian]
    # # U => [Batch, sequence length, gaussian, y_dim, dprim]

    batch = batch[:, :, None, :]
    # batch = batch.repeat(1, 1, hp.gaussians, 1)  # .unsqueeze(-2)

    d = U.shape[-2]
    dprim = U.shape[-1]

    Y = batch - mu

    YD = torch.pow(Y * torch.sqrt(D), 2)
    YDY = torch.sum(YD, -1)

    Y = Y[:, :, :, None, :]

    YU = Y @ U
    YUUY = YU @ YU.transpose(-2, -1)

    exp_term = -0.5 * (YDY + YUUY.squeeze())
    const_term = -(d / 2) * np.log(2 * math.pi)

    Dinverse = torch.div(1, torch.sqrt(D))[:, :, :, None, :]
    Utranspose = torch.transpose(U, -2, -1)
    UDinverse = Utranspose * Dinverse
    UDinverseTranspose = torch.transpose(UDinverse, -2, -1)
    UDU = torch.eye(dprim).to(hp.device)[None, None, None, :, :] + (UDinverse @ UDinverseTranspose)
    det1 = torch.logdet(UDU)
    det2 = torch.sum(torch.log(D), -1)

    log_gmm = logpi + const_term + 0.5 * (det1 + det2) + exp_term

    log_sum_exp = torch.logsumexp(log_gmm, -1)
    sum_over_sequence_length = torch.sum(log_sum_exp, -1)
    sum_over_batches = torch.sum(sum_over_sequence_length)

    return sum_over_batches

class RMDNSimple(nn.Module):
    def __init__(self, hp):
        super().__init__()
        self.gmm_linear = nn.Linear(hp.h_dim, (2 * hp.y_dim + 1) * hp.gaussians, bias=False)
        self.rnn = nn.LSTM(input_size=hp.x_dim, hidden_size=hp.h_dim, num_layers=hp.n_layers, batch_first=True, bias=False)#.flatten_parameters()
        # self.rnn = nn.LSTMCell(input_size=hp.x_dim, hidden_size=hp.h_dim, bias=False)
        # torch.nn.init.xavier_uniform_(self.rnn.weight_ih_l0)
        # torch.nn.init.xavier_uniform_(self.rnn.weight_hh_l0)
        torch.nn.init.xavier_uniform_(self.gmm_linear.weight)
        # self.relu = nn.ReLU(inplace=True)
        # self.rnn = nn.LSTM(input_size=hp.h_dim, hidden_size=hp.h_dim, num_layers=hp.n_layers, batch_first=True, bias=False)  # .flatten_parameters()
        self.hp = hp

    def forward(self, inputs):

        outs, _ = self.rnn(inputs)
        gmm_outs = self.gmm_linear(outs)

        stride = self.hp.gaussians * self.hp.y_dim

        mu = gmm_outs[:, :, :stride]
        mu = mu.view(1, -1, self.hp.gaussians, self.hp.y_dim)

        D = gmm_outs[:, :, stride: 2 * stride]
        D = D.view(1, -1, self.hp.gaussians, self.hp.y_dim)
        if (self.hp.activation == "exp"):
            # D = torch.sqrt(torch.exp(D)) + self.hp.activation_parameter
            D = torch.exp(D) + self.hp.activation_parameter
        elif (self.hp.activation == "elu"):
            # D = torch.sqrt(f.elu(D) + 1) + self.hp.activation_parameter
            D = f.elu(D) + 1 + self.hp.activation_parameter
        else: # softplus
            # D = torch.sqrt(f.softplus(D)) + self.hp.activation_parameter
            D = f.softplus(D) + self.hp.activation_parameter
        # D = torch.clamp(torch.sqrt(torch.exp(D)), min=0.1, max=1.9)

        pi = gmm_outs[:, :, 2 * stride:2 * stride +self.hp.gaussians]
        pi = pi.view(1, -1, self.hp.gaussians)
        logpi = f.log_softmax(pi, dim=-1)

        return mu, D, logpi

class RMDN_Uout(nn.Module):
    def __init__(self, hp):
        super().__init__()
        self.gmm_linear = nn.Linear(hp.h_dim, (1 + ((2 + hp.dprim) * hp.y_dim)) * hp.gaussians, bias=False)
        self.rnn = nn.LSTM(input_size=hp.x_dim, hidden_size=hp.h_dim, num_layers=hp.n_layers, batch_first=True, bias=False)#.flatten_parameters()
        # self.rnn = nn.LSTMCell(input_size=hp.x_dim, hidden_size=hp.h_dim, bias=False)
        # torch.nn.init.xavier_uniform_(self.rnn.weight_ih_l0)
        # torch.nn.init.xavier_uniform_(self.rnn.weight_hh_l0)
        torch.nn.init.xavier_uniform_(self.gmm_linear.weight)
        # self.relu = nn.ReLU(inplace=True)
        # self.rnn = nn.LSTM(input_size=hp.h_dim, hidden_size=hp.h_dim, num_layers=hp.n_layers, batch_first=True, bias=False)  # .flatten_parameters()
        self.hp = hp

    def forward(self, inputs):

        outs, _ = self.rnn(inputs)
        gmm_outs = self.gmm_linear(outs)

        stride = self.hp.gaussians * self.hp.y_dim

        mu = gmm_outs[:, :, :stride]
        mu = mu.view(1, -1, self.hp.gaussians, self.hp.y_dim)

        D = gmm_outs[:, :, stride: 2 * stride]
        D = D.view(1, -1, self.hp.gaussians, self.hp.y_dim)
        # D = torch.sqrt(torch.exp(D)) + 0.01
        # D = torch.clamp(torch.sqrt(torch.exp(D)), min=0.1, max=1.9)
        if (self.hp.activation == "exp"):
            # D = torch.sqrt(torch.exp(D)) + self.hp.activation_parameter
            D = torch.exp(D) + self.hp.activation_parameter
        elif (self.hp.activation == "elu"):
            # D = torch.sqrt(f.elu(D) + 1) + self.hp.activation_parameter
            D = f.elu(D) + 1 + self.hp.activation_parameter
        else: # softplus
            # D = torch.sqrt(f.softplus(D)) + self.hp.activation_parameter
            D = f.softplus(D) + self.hp.activation_parameter
        # D = torch.clamp(torch.sqrt(torch.exp(D)), min=0.1, max=1.9)

        pi = gmm_outs[:, :, 2 * stride:2 * stride +self.hp.gaussians]
        pi = pi.view(1, -1, self.hp.gaussians)
        logpi = f.log_softmax(pi, dim=-1)

        U = gmm_outs[:, :, 2 * stride +self.hp.gaussians:]
        U = U.view(1, -1, self.hp.gaussians, self.hp.y_dim, self.hp.dprim)
        # U = U.view(1, -1, self.hp.gaussians, self.hp.dprim, self.hp.y_dim)

        return mu, D, logpi, U

class RMDN_Udirect(nn.Module):
    def __init__(self, hp):
        super().__init__()
        self.gmm_linear = nn.Linear(hp.h_dim, (1 + (2 * hp.y_dim)) * hp.gaussians, bias=False)
        self.rnn = nn.LSTM(input_size=hp.x_dim, hidden_size=hp.h_dim, num_layers=hp.n_layers, batch_first=True, bias=False)#.flatten_parameters()
        # self.rnn = nn.LSTMCell(input_size=hp.x_dim, hidden_size=hp.h_dim, bias=False)
        # torch.nn.init.xavier_uniform_(self.rnn.weight_ih_l0)
        # torch.nn.init.xavier_uniform_(self.rnn.weight_hh_l0)
        torch.nn.init.xavier_uniform_(self.gmm_linear.weight)
        # self.relu = nn.ReLU(inplace=True)
        # self.rnn = nn.LSTM(input_size=hp.h_dim, hidden_size=hp.h_dim, num_layers=hp.n_layers, batch_first=True, bias=False)  # .flatten_parameters()
        self.hp = hp
        u_coefficient = 0.4
        self.U = torch.nn.Parameter(torch.from_numpy(u_coefficient * np.random.rand(hp.gaussians, hp.y_dim, hp.dprim)).float(), requires_grad=True)

    def forward(self, inputs):

        outs, _ = self.rnn(inputs)
        gmm_outs = self.gmm_linear(outs)

        stride = self.hp.gaussians * self.hp.y_dim

        mu = gmm_outs[:, :, :stride]
        mu = mu.view(1, -1, self.hp.gaussians, self.hp.y_dim)

        D = gmm_outs[:, :, stride: 2 * stride]
        D = D.view(1, -1, self.hp.gaussians, self.hp.y_dim)
        # D = torch.sqrt(torch.exp(D)) + 0.01
        # D = torch.clamp(torch.sqrt(torch.exp(D)), min=0.1, max=1.9)
        if (self.hp.activation == "exp"):
            # D = torch.sqrt(torch.exp(D)) + self.hp.activation_parameter
            D = torch.exp(D) + self.hp.activation_parameter
        elif (self.hp.activation == "elu"):
            # D = torch.sqrt(f.elu(D) + 1) + self.hp.activation_parameter
            D = f.elu(D) + 1 + self.hp.activation_parameter
        else: # softplus
            # D = torch.sqrt(f.softplus(D)) + self.hp.activation_parameter
            D = f.softplus(D) + self.hp.activation_parameter
        # D = torch.clamp(torch.sqrt(torch.exp(D)), min=0.1, max=1.9)

        pi = gmm_outs[:, :, 2 * stride:2 * stride +self.hp.gaussians]
        pi = pi.view(1, -1, self.hp.gaussians)
        logpi = f.log_softmax(pi, dim=-1)

        # U = gmm_outs[:, :, 2 * stride +self.hp.gaussians:]
        # U = U.view(1, -1, self.hp.gaussians, self.hp.y_dim, self.hp.dprim)

        U = self.U.repeat(mu.shape[1], 1, 1, 1).unsqueeze(0)

        return mu, D, logpi, U

    def gmm(batch, mu, D, logpi, U, hp):
        # # batch => [Batch, sequence length, y_dim]
        # # mu => [Batch, sequence length, gaussian, y_dim]
        # # D => [Batch, sequence length, gaussian, y_dim]
        # # logpi => [Batch, sequence length, gaussian]
        # # U => [Batch, sequence length, gaussian, y_dim, dprim]

        batch = batch[:, :, None, :]
        # normal_dist = Normal(mu, D)
        # g_log_probs = normal_dist.log_prob(batch)

        g_log_probs = - torch.log(D) - (0.5) * (np.log(2 * math.pi)) - (0.5) * (((batch - mu) / D) ** 2)

        g_log_probs = logpi + torch.sum(g_log_probs, dim=-1)
        # max_log_probs = torch.max(g_log_probs, dim=-1, keepdim=True)[0]
        # g_log_probs = g_log_probs - max_log_probs
        # g_probs = torch.exp(g_log_probs)
        # probs = torch.sum(g_probs, dim=-1)
        # # log_prob = max_log_probs.squeeze() + torch.log(probs)
        # log_prob = torch.log(probs)

        log_prob = torch.logsumexp(g_log_probs, -1)

        # if (reduce == True):
        return torch.sum(log_prob)
        # else:
        #     return log_prob